import { Knex } from "knex";
import { Boxed } from "knex/types";
interface PaginatorConfig {
    cursorColumn: string;
    order: "asc" | "desc";
    pageSize: number;
    orderByColumn?: string;
}
interface PaginateConfig extends PaginatorConfig {
    orderByValue?: string;
    cursor?: string;
    pageOffset?: number;
}
interface NavigationOptions {
    pageOffset?: number;
}
declare class Paginator<TRecord, TResult extends NonNullable<unknown>> {
    private state;
    private initialQuery;
    constructor(query: Knex.QueryBuilder<TRecord, TResult>, config: PaginateConfig);
    constructor(query: Knex.QueryBuilder<TRecord, TResult>, json: string);
    private exec;
    /** get the next page of results */
    next(options?: NavigationOptions): Promise<any[] | (TResult extends {
        _base: any;
        _hasSelection: any;
        _keys: any;
        _aliases: any;
        _single: any;
        _intersectProps: any;
        _unionProps: any;
    } ? Knex.ResolveTableType<TResult extends infer T ? T extends TResult ? T extends {
        _base: infer TBase;
        _hasSelection: infer THasSelect extends boolean;
        _keys: infer TKeys extends string;
        _aliases: infer TAliasMapping extends {};
        _single: infer TSingle extends boolean;
        _intersectProps: infer TIntersectProps extends {};
        _unionProps: infer TUnionProps;
    } ? (unknown extends TUnionProps | (TIntersectProps extends {} ? keyof TIntersectProps extends never ? (unknown extends TBase ? TBase : TBase) extends {} ? TSingle extends true ? TKeys extends keyof TBase ? TBase[TKeys] : any : { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } extends infer T_1 ? T_1 extends { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } ? T_1 extends {} ? keyof T_1 extends never ? true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : {} & (true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase) & T_1 : true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : never : never : unknown : {} & ((unknown extends TBase ? TBase : TBase) extends {} ? TSingle extends true ? TKeys extends keyof TBase ? TBase[TKeys] : any : { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } extends infer T_1 ? T_1 extends { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } ? T_1 extends {} ? keyof T_1 extends never ? true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : {} & (true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase) & T_1 : true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : never : never : unknown) & TIntersectProps : (unknown extends TBase ? TBase : TBase) extends {} ? TSingle extends true ? TKeys extends keyof TBase ? TBase[TKeys] : any : { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } extends infer T_1 ? T_1 extends { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } ? T_1 extends {} ? keyof T_1 extends never ? true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : {} & (true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase) & T_1 : true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : never : never : unknown) ? any : TUnionProps | (TIntersectProps extends {} ? keyof TIntersectProps extends never ? (unknown extends TBase ? TBase : TBase) extends {} ? TSingle extends true ? TKeys extends keyof TBase ? TBase[TKeys] : any : { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } extends infer T_1 ? T_1 extends { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } ? T_1 extends {} ? keyof T_1 extends never ? true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : {} & (true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase) & T_1 : true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : never : never : unknown : {} & ((unknown extends TBase ? TBase : TBase) extends {} ? TSingle extends true ? TKeys extends keyof TBase ? TBase[TKeys] : any : { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } extends infer T_1 ? T_1 extends { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } ? T_1 extends {} ? keyof T_1 extends never ? true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : {} & (true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase) & T_1 : true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : never : never : unknown) & TIntersectProps : (unknown extends TBase ? TBase : TBase) extends {} ? TSingle extends true ? TKeys extends keyof TBase ? TBase[TKeys] : any : { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } extends infer T_1 ? T_1 extends { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } ? T_1 extends {} ? keyof T_1 extends never ? true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : {} & (true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase) & T_1 : true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : never : never : unknown)) | (TUnionProps extends unknown ? (<U>() => U extends TUnionProps ? 0 : 1) extends <U_1>() => U_1 extends {} ? 0 : 1 ? any : TUnionProps : never) | ((TIntersectProps extends {} ? keyof TIntersectProps extends never ? (unknown extends TBase ? TBase : TBase) extends {} ? TSingle extends true ? TKeys extends keyof TBase ? TBase[TKeys] : any : { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } extends infer T_1 ? T_1 extends { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } ? T_1 extends {} ? keyof T_1 extends never ? true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : {} & (true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase) & T_1 : true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : never : never : unknown : {} & ((unknown extends TBase ? TBase : TBase) extends {} ? TSingle extends true ? TKeys extends keyof TBase ? TBase[TKeys] : any : { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } extends infer T_1 ? T_1 extends { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } ? T_1 extends {} ? keyof T_1 extends never ? true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : {} & (true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase) & T_1 : true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : never : never : unknown) & TIntersectProps : (unknown extends TBase ? TBase : TBase) extends {} ? TSingle extends true ? TKeys extends keyof TBase ? TBase[TKeys] : any : { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } extends infer T_1 ? T_1 extends { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } ? T_1 extends {} ? keyof T_1 extends never ? true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : {} & (true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase) & T_1 : true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : never : never : unknown) extends infer T_2 ? T_2 extends (TIntersectProps extends {} ? keyof TIntersectProps extends never ? (unknown extends TBase ? TBase : TBase) extends {} ? TSingle extends true ? TKeys extends keyof TBase ? TBase[TKeys] : any : { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } extends infer T_1 ? T_1 extends { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } ? T_1 extends {} ? keyof T_1 extends never ? true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : {} & (true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase) & T_1 : true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : never : never : unknown : {} & ((unknown extends TBase ? TBase : TBase) extends {} ? TSingle extends true ? TKeys extends keyof TBase ? TBase[TKeys] : any : { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } extends infer T_1 ? T_1 extends { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } ? T_1 extends {} ? keyof T_1 extends never ? true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : {} & (true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase) & T_1 : true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : never : never : unknown) & TIntersectProps : (unknown extends TBase ? TBase : TBase) extends {} ? TSingle extends true ? TKeys extends keyof TBase ? TBase[TKeys] : any : { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } extends infer T_1 ? T_1 extends { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } ? T_1 extends {} ? keyof T_1 extends never ? true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : {} & (true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase) & T_1 : true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : never : never : unknown) ? T_2 extends unknown ? (<U_2>() => U_2 extends T_2 ? 0 : 1) extends <U_1>() => U_1 extends {} ? 0 : 1 ? any : T_2 : never : never : never) : T : never : never, "base"> : TResult extends {
        _base: any;
        _hasSelection: any;
        _keys: any;
        _aliases: any;
        _single: any;
        _intersectProps: any;
        _unionProps: any;
    }[] ? Knex.ResolveTableType<TResult[0] extends infer T_3 ? T_3 extends TResult[0] ? T_3 extends {
        _base: infer TBase;
        _hasSelection: infer THasSelect extends boolean;
        _keys: infer TKeys extends string;
        _aliases: infer TAliasMapping extends {};
        _single: infer TSingle extends boolean;
        _intersectProps: infer TIntersectProps extends {};
        _unionProps: infer TUnionProps;
    } ? (unknown extends TUnionProps | (TIntersectProps extends {} ? keyof TIntersectProps extends never ? (unknown extends TBase ? TBase : TBase) extends {} ? TSingle extends true ? TKeys extends keyof TBase ? TBase[TKeys] : any : { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } extends infer T_1 ? T_1 extends { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } ? T_1 extends {} ? keyof T_1 extends never ? true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : {} & (true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase) & T_1 : true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : never : never : unknown : {} & ((unknown extends TBase ? TBase : TBase) extends {} ? TSingle extends true ? TKeys extends keyof TBase ? TBase[TKeys] : any : { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } extends infer T_1 ? T_1 extends { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } ? T_1 extends {} ? keyof T_1 extends never ? true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : {} & (true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase) & T_1 : true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : never : never : unknown) & TIntersectProps : (unknown extends TBase ? TBase : TBase) extends {} ? TSingle extends true ? TKeys extends keyof TBase ? TBase[TKeys] : any : { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } extends infer T_1 ? T_1 extends { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } ? T_1 extends {} ? keyof T_1 extends never ? true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : {} & (true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase) & T_1 : true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : never : never : unknown) ? any : TUnionProps | (TIntersectProps extends {} ? keyof TIntersectProps extends never ? (unknown extends TBase ? TBase : TBase) extends {} ? TSingle extends true ? TKeys extends keyof TBase ? TBase[TKeys] : any : { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } extends infer T_1 ? T_1 extends { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } ? T_1 extends {} ? keyof T_1 extends never ? true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : {} & (true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase) & T_1 : true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : never : never : unknown : {} & ((unknown extends TBase ? TBase : TBase) extends {} ? TSingle extends true ? TKeys extends keyof TBase ? TBase[TKeys] : any : { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } extends infer T_1 ? T_1 extends { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } ? T_1 extends {} ? keyof T_1 extends never ? true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : {} & (true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase) & T_1 : true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : never : never : unknown) & TIntersectProps : (unknown extends TBase ? TBase : TBase) extends {} ? TSingle extends true ? TKeys extends keyof TBase ? TBase[TKeys] : any : { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } extends infer T_1 ? T_1 extends { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } ? T_1 extends {} ? keyof T_1 extends never ? true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : {} & (true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase) & T_1 : true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : never : never : unknown)) | (TUnionProps extends unknown ? (<U>() => U extends TUnionProps ? 0 : 1) extends <U_1>() => U_1 extends {} ? 0 : 1 ? any : TUnionProps : never) | ((TIntersectProps extends {} ? keyof TIntersectProps extends never ? (unknown extends TBase ? TBase : TBase) extends {} ? TSingle extends true ? TKeys extends keyof TBase ? TBase[TKeys] : any : { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } extends infer T_1 ? T_1 extends { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } ? T_1 extends {} ? keyof T_1 extends never ? true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : {} & (true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase) & T_1 : true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : never : never : unknown : {} & ((unknown extends TBase ? TBase : TBase) extends {} ? TSingle extends true ? TKeys extends keyof TBase ? TBase[TKeys] : any : { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } extends infer T_1 ? T_1 extends { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } ? T_1 extends {} ? keyof T_1 extends never ? true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : {} & (true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase) & T_1 : true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : never : never : unknown) & TIntersectProps : (unknown extends TBase ? TBase : TBase) extends {} ? TSingle extends true ? TKeys extends keyof TBase ? TBase[TKeys] : any : { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } extends infer T_1 ? T_1 extends { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } ? T_1 extends {} ? keyof T_1 extends never ? true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : {} & (true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase) & T_1 : true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : never : never : unknown) extends infer T_2 ? T_2 extends (TIntersectProps extends {} ? keyof TIntersectProps extends never ? (unknown extends TBase ? TBase : TBase) extends {} ? TSingle extends true ? TKeys extends keyof TBase ? TBase[TKeys] : any : { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } extends infer T_1 ? T_1 extends { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } ? T_1 extends {} ? keyof T_1 extends never ? true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : {} & (true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase) & T_1 : true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : never : never : unknown : {} & ((unknown extends TBase ? TBase : TBase) extends {} ? TSingle extends true ? TKeys extends keyof TBase ? TBase[TKeys] : any : { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } extends infer T_1 ? T_1 extends { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } ? T_1 extends {} ? keyof T_1 extends never ? true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : {} & (true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase) & T_1 : true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : never : never : unknown) & TIntersectProps : (unknown extends TBase ? TBase : TBase) extends {} ? TSingle extends true ? TKeys extends keyof TBase ? TBase[TKeys] : any : { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } extends infer T_1 ? T_1 extends { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } ? T_1 extends {} ? keyof T_1 extends never ? true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : {} & (true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase) & T_1 : true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : never : never : unknown) ? T_2 extends unknown ? (<U_2>() => U_2 extends T_2 ? 0 : 1) extends <U_1>() => U_1 extends {} ? 0 : 1 ? any : T_2 : never : never : never) : T_3 : never : never, "base">[] : TResult extends (infer I)[] ? ((unknown extends Knex.ResolveTableType<I, "base"> ? any : Knex.ResolveTableType<I, "base">) | (Knex.ResolveTableType<I, "base"> extends infer T_4 ? T_4 extends Knex.ResolveTableType<I, "base"> ? T_4 extends unknown ? (<U_3>() => U_3 extends T_4 ? 0 : 1) extends <U_1>() => U_1 extends {} ? 0 : 1 ? any : T_4 : never : never : never))[] : (unknown extends Knex.ResolveTableType<TResult, "base"> ? any : Knex.ResolveTableType<TResult, "base">) | (Knex.ResolveTableType<TResult, "base"> extends infer T_5 ? T_5 extends Knex.ResolveTableType<TResult, "base"> ? T_5 extends unknown ? (<U_4>() => U_4 extends T_5 ? 0 : 1) extends <U_1>() => U_1 extends {} ? 0 : 1 ? any : T_5 : never : never : never))>;
    /** get the previous page of results */
    previous(options?: NavigationOptions): Promise<any[] | (TResult extends {
        _base: any;
        _hasSelection: any;
        _keys: any;
        _aliases: any;
        _single: any;
        _intersectProps: any;
        _unionProps: any;
    } ? Knex.ResolveTableType<TResult extends infer T ? T extends TResult ? T extends {
        _base: infer TBase;
        _hasSelection: infer THasSelect extends boolean;
        _keys: infer TKeys extends string;
        _aliases: infer TAliasMapping extends {};
        _single: infer TSingle extends boolean;
        _intersectProps: infer TIntersectProps extends {};
        _unionProps: infer TUnionProps;
    } ? (unknown extends TUnionProps | (TIntersectProps extends {} ? keyof TIntersectProps extends never ? (unknown extends TBase ? TBase : TBase) extends {} ? TSingle extends true ? TKeys extends keyof TBase ? TBase[TKeys] : any : { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } extends infer T_1 ? T_1 extends { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } ? T_1 extends {} ? keyof T_1 extends never ? true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : {} & (true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase) & T_1 : true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : never : never : unknown : {} & ((unknown extends TBase ? TBase : TBase) extends {} ? TSingle extends true ? TKeys extends keyof TBase ? TBase[TKeys] : any : { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } extends infer T_1 ? T_1 extends { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } ? T_1 extends {} ? keyof T_1 extends never ? true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : {} & (true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase) & T_1 : true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : never : never : unknown) & TIntersectProps : (unknown extends TBase ? TBase : TBase) extends {} ? TSingle extends true ? TKeys extends keyof TBase ? TBase[TKeys] : any : { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } extends infer T_1 ? T_1 extends { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } ? T_1 extends {} ? keyof T_1 extends never ? true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : {} & (true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase) & T_1 : true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : never : never : unknown) ? any : TUnionProps | (TIntersectProps extends {} ? keyof TIntersectProps extends never ? (unknown extends TBase ? TBase : TBase) extends {} ? TSingle extends true ? TKeys extends keyof TBase ? TBase[TKeys] : any : { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } extends infer T_1 ? T_1 extends { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } ? T_1 extends {} ? keyof T_1 extends never ? true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : {} & (true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase) & T_1 : true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : never : never : unknown : {} & ((unknown extends TBase ? TBase : TBase) extends {} ? TSingle extends true ? TKeys extends keyof TBase ? TBase[TKeys] : any : { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } extends infer T_1 ? T_1 extends { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } ? T_1 extends {} ? keyof T_1 extends never ? true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : {} & (true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase) & T_1 : true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : never : never : unknown) & TIntersectProps : (unknown extends TBase ? TBase : TBase) extends {} ? TSingle extends true ? TKeys extends keyof TBase ? TBase[TKeys] : any : { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } extends infer T_1 ? T_1 extends { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } ? T_1 extends {} ? keyof T_1 extends never ? true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : {} & (true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase) & T_1 : true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : never : never : unknown)) | (TUnionProps extends unknown ? (<U>() => U extends TUnionProps ? 0 : 1) extends <U_1>() => U_1 extends {} ? 0 : 1 ? any : TUnionProps : never) | ((TIntersectProps extends {} ? keyof TIntersectProps extends never ? (unknown extends TBase ? TBase : TBase) extends {} ? TSingle extends true ? TKeys extends keyof TBase ? TBase[TKeys] : any : { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } extends infer T_1 ? T_1 extends { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } ? T_1 extends {} ? keyof T_1 extends never ? true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : {} & (true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase) & T_1 : true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : never : never : unknown : {} & ((unknown extends TBase ? TBase : TBase) extends {} ? TSingle extends true ? TKeys extends keyof TBase ? TBase[TKeys] : any : { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } extends infer T_1 ? T_1 extends { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } ? T_1 extends {} ? keyof T_1 extends never ? true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : {} & (true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase) & T_1 : true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : never : never : unknown) & TIntersectProps : (unknown extends TBase ? TBase : TBase) extends {} ? TSingle extends true ? TKeys extends keyof TBase ? TBase[TKeys] : any : { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } extends infer T_1 ? T_1 extends { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } ? T_1 extends {} ? keyof T_1 extends never ? true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : {} & (true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase) & T_1 : true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : never : never : unknown) extends infer T_2 ? T_2 extends (TIntersectProps extends {} ? keyof TIntersectProps extends never ? (unknown extends TBase ? TBase : TBase) extends {} ? TSingle extends true ? TKeys extends keyof TBase ? TBase[TKeys] : any : { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } extends infer T_1 ? T_1 extends { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } ? T_1 extends {} ? keyof T_1 extends never ? true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : {} & (true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase) & T_1 : true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : never : never : unknown : {} & ((unknown extends TBase ? TBase : TBase) extends {} ? TSingle extends true ? TKeys extends keyof TBase ? TBase[TKeys] : any : { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } extends infer T_1 ? T_1 extends { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } ? T_1 extends {} ? keyof T_1 extends never ? true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : {} & (true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase) & T_1 : true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : never : never : unknown) & TIntersectProps : (unknown extends TBase ? TBase : TBase) extends {} ? TSingle extends true ? TKeys extends keyof TBase ? TBase[TKeys] : any : { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } extends infer T_1 ? T_1 extends { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } ? T_1 extends {} ? keyof T_1 extends never ? true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : {} & (true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase) & T_1 : true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : never : never : unknown) ? T_2 extends unknown ? (<U_2>() => U_2 extends T_2 ? 0 : 1) extends <U_1>() => U_1 extends {} ? 0 : 1 ? any : T_2 : never : never : never) : T : never : never, "base"> : TResult extends {
        _base: any;
        _hasSelection: any;
        _keys: any;
        _aliases: any;
        _single: any;
        _intersectProps: any;
        _unionProps: any;
    }[] ? Knex.ResolveTableType<TResult[0] extends infer T_3 ? T_3 extends TResult[0] ? T_3 extends {
        _base: infer TBase;
        _hasSelection: infer THasSelect extends boolean;
        _keys: infer TKeys extends string;
        _aliases: infer TAliasMapping extends {};
        _single: infer TSingle extends boolean;
        _intersectProps: infer TIntersectProps extends {};
        _unionProps: infer TUnionProps;
    } ? (unknown extends TUnionProps | (TIntersectProps extends {} ? keyof TIntersectProps extends never ? (unknown extends TBase ? TBase : TBase) extends {} ? TSingle extends true ? TKeys extends keyof TBase ? TBase[TKeys] : any : { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } extends infer T_1 ? T_1 extends { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } ? T_1 extends {} ? keyof T_1 extends never ? true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : {} & (true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase) & T_1 : true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : never : never : unknown : {} & ((unknown extends TBase ? TBase : TBase) extends {} ? TSingle extends true ? TKeys extends keyof TBase ? TBase[TKeys] : any : { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } extends infer T_1 ? T_1 extends { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } ? T_1 extends {} ? keyof T_1 extends never ? true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : {} & (true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase) & T_1 : true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : never : never : unknown) & TIntersectProps : (unknown extends TBase ? TBase : TBase) extends {} ? TSingle extends true ? TKeys extends keyof TBase ? TBase[TKeys] : any : { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } extends infer T_1 ? T_1 extends { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } ? T_1 extends {} ? keyof T_1 extends never ? true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : {} & (true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase) & T_1 : true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : never : never : unknown) ? any : TUnionProps | (TIntersectProps extends {} ? keyof TIntersectProps extends never ? (unknown extends TBase ? TBase : TBase) extends {} ? TSingle extends true ? TKeys extends keyof TBase ? TBase[TKeys] : any : { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } extends infer T_1 ? T_1 extends { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } ? T_1 extends {} ? keyof T_1 extends never ? true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : {} & (true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase) & T_1 : true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : never : never : unknown : {} & ((unknown extends TBase ? TBase : TBase) extends {} ? TSingle extends true ? TKeys extends keyof TBase ? TBase[TKeys] : any : { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } extends infer T_1 ? T_1 extends { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } ? T_1 extends {} ? keyof T_1 extends never ? true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : {} & (true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase) & T_1 : true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : never : never : unknown) & TIntersectProps : (unknown extends TBase ? TBase : TBase) extends {} ? TSingle extends true ? TKeys extends keyof TBase ? TBase[TKeys] : any : { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } extends infer T_1 ? T_1 extends { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } ? T_1 extends {} ? keyof T_1 extends never ? true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : {} & (true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase) & T_1 : true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : never : never : unknown)) | (TUnionProps extends unknown ? (<U>() => U extends TUnionProps ? 0 : 1) extends <U_1>() => U_1 extends {} ? 0 : 1 ? any : TUnionProps : never) | ((TIntersectProps extends {} ? keyof TIntersectProps extends never ? (unknown extends TBase ? TBase : TBase) extends {} ? TSingle extends true ? TKeys extends keyof TBase ? TBase[TKeys] : any : { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } extends infer T_1 ? T_1 extends { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } ? T_1 extends {} ? keyof T_1 extends never ? true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : {} & (true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase) & T_1 : true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : never : never : unknown : {} & ((unknown extends TBase ? TBase : TBase) extends {} ? TSingle extends true ? TKeys extends keyof TBase ? TBase[TKeys] : any : { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } extends infer T_1 ? T_1 extends { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } ? T_1 extends {} ? keyof T_1 extends never ? true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : {} & (true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase) & T_1 : true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : never : never : unknown) & TIntersectProps : (unknown extends TBase ? TBase : TBase) extends {} ? TSingle extends true ? TKeys extends keyof TBase ? TBase[TKeys] : any : { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } extends infer T_1 ? T_1 extends { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } ? T_1 extends {} ? keyof T_1 extends never ? true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : {} & (true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase) & T_1 : true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : never : never : unknown) extends infer T_2 ? T_2 extends (TIntersectProps extends {} ? keyof TIntersectProps extends never ? (unknown extends TBase ? TBase : TBase) extends {} ? TSingle extends true ? TKeys extends keyof TBase ? TBase[TKeys] : any : { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } extends infer T_1 ? T_1 extends { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } ? T_1 extends {} ? keyof T_1 extends never ? true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : {} & (true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase) & T_1 : true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : never : never : unknown : {} & ((unknown extends TBase ? TBase : TBase) extends {} ? TSingle extends true ? TKeys extends keyof TBase ? TBase[TKeys] : any : { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } extends infer T_1 ? T_1 extends { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } ? T_1 extends {} ? keyof T_1 extends never ? true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : {} & (true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase) & T_1 : true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : never : never : unknown) & TIntersectProps : (unknown extends TBase ? TBase : TBase) extends {} ? TSingle extends true ? TKeys extends keyof TBase ? TBase[TKeys] : any : { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } extends infer T_1 ? T_1 extends { [K in keyof TAliasMapping]: TAliasMapping[K] extends keyof TBase ? TBase[TAliasMapping[K]] : any; } ? T_1 extends {} ? keyof T_1 extends never ? true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : {} & (true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase) & T_1 : true extends THasSelect ? Boxed<TKeys> extends Boxed<never> ? {} : Boxed<TKeys> extends Boxed<keyof TBase> ? TBase extends {} ? Pick<TBase, TKeys & keyof TBase> : any : any : TBase : never : never : unknown) ? T_2 extends unknown ? (<U_2>() => U_2 extends T_2 ? 0 : 1) extends <U_1>() => U_1 extends {} ? 0 : 1 ? any : T_2 : never : never : never) : T_3 : never : never, "base">[] : TResult extends (infer I)[] ? ((unknown extends Knex.ResolveTableType<I, "base"> ? any : Knex.ResolveTableType<I, "base">) | (Knex.ResolveTableType<I, "base"> extends infer T_4 ? T_4 extends Knex.ResolveTableType<I, "base"> ? T_4 extends unknown ? (<U_3>() => U_3 extends T_4 ? 0 : 1) extends <U_1>() => U_1 extends {} ? 0 : 1 ? any : T_4 : never : never : never))[] : (unknown extends Knex.ResolveTableType<TResult, "base"> ? any : Knex.ResolveTableType<TResult, "base">) | (Knex.ResolveTableType<TResult, "base"> extends infer T_5 ? T_5 extends Knex.ResolveTableType<TResult, "base"> ? T_5 extends unknown ? (<U_4>() => U_4 extends T_5 ? 0 : 1) extends <U_1>() => U_1 extends {} ? 0 : 1 ? any : T_5 : never : never : never))>;
    get value(): {
        orderByColumnName: string;
        cursorColumnName: string;
        tailCursor?: string;
        tailOrderByValue?: string;
        orderByValue?: string;
        cursor?: string;
        pageOffset?: number;
        cursorColumn: string;
        order: "desc" | "asc";
        pageSize: number;
        orderByColumn?: string;
    };
    toJSON(): {
        orderByColumnName: string;
        cursorColumnName: string;
        tailCursor?: string;
        tailOrderByValue?: string;
        orderByValue?: string;
        cursor?: string;
        pageOffset?: number;
        cursorColumn: string;
        order: "desc" | "asc";
        pageSize: number;
        orderByColumn?: string;
    };
}
declare function paginate<TRecord, TResult>(query: Knex.QueryBuilder<TRecord, TResult>, config: PaginateConfig): Knex.QueryBuilder<TRecord, TResult>;
export { Paginator, PaginateConfig, paginate };
